# GstMediaSource

GstMediaSource is the entry point into the W3C Media Source API. It offers functionality similar to GstAppSrc for client-side web or JavaScript applications decoupling the source of media from its processing and playback.

To interact with a Media Source, connect it to a GstMseSrc that is in some GstPipeline using gst_media_source_attach. Then create at least one GstSourceBuffer using gst_media_source_add_source_buffer. Finally, feed some media data to the Source Buffer(s) using gst_source_buffer_append_buffer and play the pipeline.

## GstMediaSource

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstMediaSource

Since : 1.24

### Class structure

#### GstMediaSourceClass

##### Fields

`parent_class` (GstObjectClass) –
No description available

### GstMse.MediaSourceClass

##### Attributes

`parent_class` (Gst.ObjectClass) –
No description available

### GstMse.MediaSourceClass

##### Attributes

`parent_class` (Gst.ObjectClass) –
No description available

## GstMse.MediaSource

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──GstMse.MediaSource

Since : 1.24

## GstMse.MediaSource

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──GstMse.MediaSource

Since : 1.24

### Constructors

#### gst_media_source_new

    GstMediaSource *
    gst_media_source_new ()

Creates a new GstMediaSource instance. The instance is in the GST_MEDIA_SOURCE_READY_STATE_CLOSED state and is not associated with any media player.

Specification

Returns ( [transfer: full]) –

a new GstMediaSource instance

Since : 1.24

#### GstMse.MediaSource.prototype.new

    function GstMse.MediaSource.prototype.new(): {
        // javascript wrapper for 'gst_media_source_new'
    }

Creates a new GstMse.MediaSource instance. The instance is in the GstMse.MediaSourceReadyState.CLOSED state and is not associated with any media player.

Specification

Returns (GstMse.MediaSource) –

a new GstMse.MediaSource instance

Since : 1.24

#### GstMse.MediaSource.new

    def GstMse.MediaSource.new ():
        #python wrapper for 'gst_media_source_new'

Creates a new GstMse.MediaSource instance. The instance is in the GstMse.MediaSourceReadyState.CLOSED state and is not associated with any media player.

Specification

Returns (GstMse.MediaSource) –

a new GstMse.MediaSource instance

Since : 1.24

### Methods

#### gst_media_source_add_source_buffer

    GstSourceBuffer *
    gst_media_source_add_source_buffer (GstMediaSource * self,
                                        const gchar* type,
                                        GError ** error)

Add a GstSourceBuffer to this GstMediaSource of the specified media type. The Media Source must be in the GstMediaSourceReadyState GST_MEDIA_SOURCE_READY_STATE_OPEN.

Specification

Parameters:

`self` –

GstMediaSource instance

`type` ( [transfer: none]) –

A MIME type describing the format of the incoming media

`error` ( [out][optional][nullable][transfer: full]) –

the resulting error or `NULL`

Returns ( [transfer: full]) –

a new GstSourceBuffer instance on success, otherwise `NULL`

Since : 1.24

#### GstMse.MediaSource.prototype.add_source_buffer

    function GstMse.MediaSource.prototype.add_source_buffer(type: String): {
        // javascript wrapper for 'gst_media_source_add_source_buffer'
    }

Add a GstMse.SourceBuffer to this GstMse.MediaSource of the specified media type. The Media Source must be in the GstMse.MediaSourceReadyState GstMse.MediaSourceReadyState.OPEN.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

`type` (String) –

A MIME type describing the format of the incoming media

Returns (GstMse.SourceBuffer) –

a new GstMse.SourceBuffer instance on success, otherwise `NULL`

Since : 1.24

#### GstMse.MediaSource.add_source_buffer

    @raises(GLib.GError)
    def GstMse.MediaSource.add_source_buffer (self, type):
        #python wrapper for 'gst_media_source_add_source_buffer'

Add a GstMse.SourceBuffer to this GstMse.MediaSource of the specified media type. The Media Source must be in the GstMse.MediaSourceReadyState GstMse.MediaSourceReadyState.OPEN.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

`type` (str) –

A MIME type describing the format of the incoming media

Returns (GstMse.SourceBuffer) –

a new GstMse.SourceBuffer instance on success, otherwise `NULL`

Since : 1.24

#### gst_media_source_attach

    gst_media_source_attach (GstMediaSource * self,
                             GstMseSrc * element)

Associates self with element. Normally, the Element will be part of a GstPipeline that plays back the data submitted to the Media Source's Source Buffers.

GstMseSrc is a special source element that is designed to consume media from a GstMediaSource.

Specification

Parameters:

`self` –

GstMediaSource instance

`element` ( [transfer: none]) –

GstMseSrc source Element

Since : 1.24

#### GstMse.MediaSource.prototype.attach

    function GstMse.MediaSource.prototype.attach(element: GstMse.MseSrc): {
        // javascript wrapper for 'gst_media_source_attach'
    }

Associates self with element. Normally, the Element will be part of a Gst.Pipeline that plays back the data submitted to the Media Source's Source Buffers.

GstMse.MseSrc is a special source element that is designed to consume media from a GstMse.MediaSource.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

`element` (GstMse.MseSrc) –

GstMse.MseSrc source Element

Since : 1.24

#### GstMse.MediaSource.attach

    def GstMse.MediaSource.attach (self, element):
        #python wrapper for 'gst_media_source_attach'

Associates self with element. Normally, the Element will be part of a Gst.Pipeline that plays back the data submitted to the Media Source's Source Buffers.

GstMse.MseSrc is a special source element that is designed to consume media from a GstMse.MediaSource.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

`element` (GstMse.MseSrc) –

GstMse.MseSrc source Element

Since : 1.24

#### gst_media_source_clear_live_seekable_range

    gboolean
    gst_media_source_clear_live_seekable_range (GstMediaSource * self,
                                                GError ** error)

Clear the live seekable range for self. This will inform the component playing this Media Source that there is no seekable time range.

If the ready state is not GST_MEDIA_SOURCE_READY_STATE_OPEN, it will fail and set an error.

Specification

Parameters:

`self` –

GstMediaSource instance

`error` ( [out][optional][nullable][transfer: full]) –

the resulting error or `NULL`

Returns –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

#### GstMse.MediaSource.prototype.clear_live_seekable_range

    function GstMse.MediaSource.prototype.clear_live_seekable_range(): {
        // javascript wrapper for 'gst_media_source_clear_live_seekable_range'
    }

Clear the live seekable range for self. This will inform the component playing this Media Source that there is no seekable time range.

If the ready state is not GstMse.MediaSourceReadyState.OPEN, it will fail and set an error.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Returns (Number) –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

#### GstMse.MediaSource.clear_live_seekable_range

    @raises(GLib.GError)
    def GstMse.MediaSource.clear_live_seekable_range (self):
        #python wrapper for 'gst_media_source_clear_live_seekable_range'

Clear the live seekable range for self. This will inform the component playing this Media Source that there is no seekable time range.

If the ready state is not GstMse.MediaSourceReadyState.OPEN, it will fail and set an error.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Returns (bool) –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

#### gst_media_source_detach

    gst_media_source_detach (GstMediaSource * self)

Detaches self from any GstMseSrc element that it may be associated with.

Parameters:

`self` –

GstMediaSource instance

Since : 1.24

#### GstMse.MediaSource.prototype.detach

    function GstMse.MediaSource.prototype.detach(): {
        // javascript wrapper for 'gst_media_source_detach'
    }

Detaches self from any GstMse.MseSrc element that it may be associated with.

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Since : 1.24

#### GstMse.MediaSource.detach

    def GstMse.MediaSource.detach (self):
        #python wrapper for 'gst_media_source_detach'

Detaches self from any GstMse.MseSrc element that it may be associated with.

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Since : 1.24

#### gst_media_source_end_of_stream

    gboolean
    gst_media_source_end_of_stream (GstMediaSource * self,
                                    GstMediaSourceEOSError eos_error,
                                    GError ** error)

Mark self as reaching the end of stream, disallowing new data inputs.

Specification

Parameters:

`self` –

GstMediaSource instance

`eos_error` –

The error type, if any

`error` ( [out][optional][nullable][transfer: full]) –

the resulting error or `NULL`

Returns –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

#### GstMse.MediaSource.prototype.end_of_stream

    function GstMse.MediaSource.prototype.end_of_stream(eos_error: GstMse.MediaSourceEOSError): {
        // javascript wrapper for 'gst_media_source_end_of_stream'
    }

Mark self as reaching the end of stream, disallowing new data inputs.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

`eos_error` (GstMse.MediaSourceEOSError) –

The error type, if any

Returns (Number) –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

#### GstMse.MediaSource.end_of_stream

    @raises(GLib.GError)
    def GstMse.MediaSource.end_of_stream (self, eos_error):
        #python wrapper for 'gst_media_source_end_of_stream'

Mark self as reaching the end of stream, disallowing new data inputs.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

`eos_error` (GstMse.MediaSourceEOSError) –

The error type, if any

Returns (bool) –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

#### gst_media_source_get_active_source_buffers

    GstSourceBufferList *
    gst_media_source_get_active_source_buffers (GstMediaSource * self)

Gets a GstSourceBufferList containing all the Source Buffers currently associated with this Media Source that are considered "active." For a Source Buffer to be considered active, either its video track is selected, its audio track is enabled, or its text track is visible or hidden. This object will reflect any future changes to the parent Media Source as well.

Specification

Parameters:

`self` –

GstMediaSource instance

Returns ( [transfer: full]) –

a new GstSourceBufferList instance

Since : 1.24

#### GstMse.MediaSource.prototype.get_active_source_buffers

    function GstMse.MediaSource.prototype.get_active_source_buffers(): {
        // javascript wrapper for 'gst_media_source_get_active_source_buffers'
    }

Gets a GstMse.SourceBufferList containing all the Source Buffers currently associated with this Media Source that are considered "active." For a Source Buffer to be considered active, either its video track is selected, its audio track is enabled, or its text track is visible or hidden. This object will reflect any future changes to the parent Media Source as well.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Returns (GstMse.SourceBufferList) –

a new GstMse.SourceBufferList instance

Since : 1.24

#### GstMse.MediaSource.get_active_source_buffers

    def GstMse.MediaSource.get_active_source_buffers (self):
        #python wrapper for 'gst_media_source_get_active_source_buffers'

Gets a GstMse.SourceBufferList containing all the Source Buffers currently associated with this Media Source that are considered "active." For a Source Buffer to be considered active, either its video track is selected, its audio track is enabled, or its text track is visible or hidden. This object will reflect any future changes to the parent Media Source as well.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Returns (GstMse.SourceBufferList) –

a new GstMse.SourceBufferList instance

Since : 1.24

#### gst_media_source_get_duration

    GstClockTime
    gst_media_source_get_duration (GstMediaSource * self)

Gets the current duration of self.

Specification

Parameters:

`self` –

GstMediaSource instance

Returns –

the current duration as a GstClockTime

Since : 1.24

#### GstMse.MediaSource.prototype.get_duration

    function GstMse.MediaSource.prototype.get_duration(): {
        // javascript wrapper for 'gst_media_source_get_duration'
    }

Gets the current duration of self.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Returns (Number) –

the current duration as a Number

Since : 1.24

#### GstMse.MediaSource.get_duration

    def GstMse.MediaSource.get_duration (self):
        #python wrapper for 'gst_media_source_get_duration'

Gets the current duration of self.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Returns (int) –

the current duration as a int

Since : 1.24

#### gst_media_source_get_live_seekable_range

    gst_media_source_get_live_seekable_range (GstMediaSource * self,
                                              GstMediaSourceRange * range)

Get the live seekable range of self. Will fill in the supplied range with the current live seekable range.

Parameters:

`self` –

GstMediaSource instance

`range` ( [out][transfer: none]) –

time range

Since : 1.24

#### GstMse.MediaSource.prototype.get_live_seekable_range

    function GstMse.MediaSource.prototype.get_live_seekable_range(): {
        // javascript wrapper for 'gst_media_source_get_live_seekable_range'
    }

Get the live seekable range of self. Will fill in the supplied range with the current live seekable range.

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Since : 1.24

#### GstMse.MediaSource.get_live_seekable_range

    def GstMse.MediaSource.get_live_seekable_range (self):
        #python wrapper for 'gst_media_source_get_live_seekable_range'

Get the live seekable range of self. Will fill in the supplied range with the current live seekable range.

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Since : 1.24

#### gst_media_source_get_position

    GstClockTime
    gst_media_source_get_position (GstMediaSource * self)

Gets the current playback position of the Media Source.

Parameters:

`self` –

GstMediaSource instance

Returns –

the current playback position as a GstClockTime

Since : 1.24

#### GstMse.MediaSource.prototype.get_position

    function GstMse.MediaSource.prototype.get_position(): {
        // javascript wrapper for 'gst_media_source_get_position'
    }

Gets the current playback position of the Media Source.

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Returns (Number) –

the current playback position as a Number

Since : 1.24

#### GstMse.MediaSource.get_position

    def GstMse.MediaSource.get_position (self):
        #python wrapper for 'gst_media_source_get_position'

Gets the current playback position of the Media Source.

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Returns (int) –

the current playback position as a int

Since : 1.24

#### gst_media_source_get_ready_state

    GstMediaSourceReadyState
    gst_media_source_get_ready_state (GstMediaSource * self)

Gets the current Ready State of the Media Source.

Specification

Parameters:

`self` –

GstMediaSource instance

Returns –

the current GstMediaSourceReadyState value

Since : 1.24

#### GstMse.MediaSource.prototype.get_ready_state

    function GstMse.MediaSource.prototype.get_ready_state(): {
        // javascript wrapper for 'gst_media_source_get_ready_state'
    }

Gets the current Ready State of the Media Source.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Returns (GstMse.MediaSourceReadyState) –

the current GstMse.MediaSourceReadyState value

Since : 1.24

#### GstMse.MediaSource.get_ready_state

    def GstMse.MediaSource.get_ready_state (self):
        #python wrapper for 'gst_media_source_get_ready_state'

Gets the current Ready State of the Media Source.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Returns (GstMse.MediaSourceReadyState) –

the current GstMse.MediaSourceReadyState value

Since : 1.24

#### gst_media_source_get_source_buffers

    GstSourceBufferList *
    gst_media_source_get_source_buffers (GstMediaSource * self)

Gets a GstSourceBufferList containing all the Source Buffers currently associated with this Media Source. This object will reflect any future changes to the parent Media Source as well.

Specification

Parameters:

`self` –

GstMediaSource instance

Returns ( [transfer: full]) –

a GstSourceBufferList instance

Since : 1.24

#### GstMse.MediaSource.prototype.get_source_buffers

    function GstMse.MediaSource.prototype.get_source_buffers(): {
        // javascript wrapper for 'gst_media_source_get_source_buffers'
    }

Gets a GstMse.SourceBufferList containing all the Source Buffers currently associated with this Media Source. This object will reflect any future changes to the parent Media Source as well.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Returns (GstMse.SourceBufferList) –

a GstMse.SourceBufferList instance

Since : 1.24

#### GstMse.MediaSource.get_source_buffers

    def GstMse.MediaSource.get_source_buffers (self):
        #python wrapper for 'gst_media_source_get_source_buffers'

Gets a GstMse.SourceBufferList containing all the Source Buffers currently associated with this Media Source. This object will reflect any future changes to the parent Media Source as well.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

Returns (GstMse.SourceBufferList) –

a GstMse.SourceBufferList instance

Since : 1.24

#### gst_media_source_remove_source_buffer

    gboolean
    gst_media_source_remove_source_buffer (GstMediaSource * self,
                                           GstSourceBuffer * buffer,
                                           GError ** error)

Remove buffer from self.

buffer must have been created as a child of self and self must be in the GstMediaSourceReadyState GST_MEDIA_SOURCE_READY_STATE_OPEN.

Specification

Parameters:

`self` –

GstMediaSource instance

`buffer` ( [transfer: none]) –

GstSourceBuffer instance

`error` ( [out][optional][nullable][transfer: full]) –

the resulting error or `NULL`

Returns –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

#### GstMse.MediaSource.prototype.remove_source_buffer

    function GstMse.MediaSource.prototype.remove_source_buffer(buffer: GstMse.SourceBuffer): {
        // javascript wrapper for 'gst_media_source_remove_source_buffer'
    }

Remove buffer from self.

buffer must have been created as a child of self and self must be in the GstMse.MediaSourceReadyState GstMse.MediaSourceReadyState.OPEN.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

`buffer` (GstMse.SourceBuffer) –

GstMse.SourceBuffer instance

Returns (Number) –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

#### GstMse.MediaSource.remove_source_buffer

    @raises(GLib.GError)
    def GstMse.MediaSource.remove_source_buffer (self, buffer):
        #python wrapper for 'gst_media_source_remove_source_buffer'

Remove buffer from self.

buffer must have been created as a child of self and self must be in the GstMse.MediaSourceReadyState GstMse.MediaSourceReadyState.OPEN.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

`buffer` (GstMse.SourceBuffer) –

GstMse.SourceBuffer instance

Returns (bool) –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

#### gst_media_source_set_duration

    gboolean
    gst_media_source_set_duration (GstMediaSource * self,
                                   GstClockTime duration,
                                   GError ** error)

Sets the duration of self.

Specification

Parameters:

`self` –

GstMediaSource instance

`duration` –

The new duration to apply to self.

`error` ( [out][optional][nullable][transfer: full]) –

the resulting error or `NULL`

Returns –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

#### GstMse.MediaSource.prototype.set_duration

    function GstMse.MediaSource.prototype.set_duration(duration: Number): {
        // javascript wrapper for 'gst_media_source_set_duration'
    }

Sets the duration of self.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

`duration` (Number) –

The new duration to apply to self.

Returns (Number) –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

#### GstMse.MediaSource.set_duration

    @raises(GLib.GError)
    def GstMse.MediaSource.set_duration (self, duration):
        #python wrapper for 'gst_media_source_set_duration'

Sets the duration of self.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

`duration` (int) –

The new duration to apply to self.

Returns (bool) –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

#### gst_media_source_set_live_seekable_range

    gboolean
    gst_media_source_set_live_seekable_range (GstMediaSource * self,
                                              GstClockTime start,
                                              GstClockTime end,
                                              GError ** error)

Set the live seekable range for self. This range informs the component playing this Media Source what it can allow the user to seek through.

If the ready state is not GST_MEDIA_SOURCE_READY_STATE_OPEN, or the supplied start time is later than end it will fail and set an error.

Specification

Parameters:

`self` –

GstMediaSource instance

`start` –

The earliest point in the stream considered seekable

`end` –

The latest point in the stream considered seekable

`error` ( [out][optional][nullable][transfer: full]) –

the resulting error or `NULL`

Returns –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

#### GstMse.MediaSource.prototype.set_live_seekable_range

    function GstMse.MediaSource.prototype.set_live_seekable_range(start: Number, end: Number): {
        // javascript wrapper for 'gst_media_source_set_live_seekable_range'
    }

Set the live seekable range for self. This range informs the component playing this Media Source what it can allow the user to seek through.

If the ready state is not GstMse.MediaSourceReadyState.OPEN, or the supplied start time is later than end it will fail and set an error.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

`start` (Number) –

The earliest point in the stream considered seekable

`end` (Number) –

The latest point in the stream considered seekable

Returns (Number) –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

#### GstMse.MediaSource.set_live_seekable_range

    @raises(GLib.GError)
    def GstMse.MediaSource.set_live_seekable_range (self, start, end):
        #python wrapper for 'gst_media_source_set_live_seekable_range'

Set the live seekable range for self. This range informs the component playing this Media Source what it can allow the user to seek through.

If the ready state is not GstMse.MediaSourceReadyState.OPEN, or the supplied start time is later than end it will fail and set an error.

Specification

Parameters:

`self` (GstMse.MediaSource) –

GstMse.MediaSource instance

`start` (int) –

The earliest point in the stream considered seekable

`end` (int) –

The latest point in the stream considered seekable

Returns (bool) –

`TRUE` on success, `FALSE` otherwise

Since : 1.24

### Functions

#### gst_media_source_is_type_supported

    gboolean
    gst_media_source_is_type_supported (const gchar* type)

Determines whether the current Media Source configuration can process media of the supplied type.

Parameters:

`type` ( [transfer: none]) –

A MIME type value

Returns –

`TRUE` when supported, `FALSE` otherwise

Since : 1.24

#### GstMse.MediaSource.prototype.is_type_supported

    function GstMse.MediaSource.prototype.is_type_supported(type: String): {
        // javascript wrapper for 'gst_media_source_is_type_supported'
    }

Determines whether the current Media Source configuration can process media of the supplied type.

Parameters:

`type` (String) –

A MIME type value

Returns (Number) –

`TRUE` when supported, `FALSE` otherwise

Since : 1.24

#### GstMse.MediaSource.is_type_supported

    def GstMse.MediaSource.is_type_supported (type):
        #python wrapper for 'gst_media_source_is_type_supported'

Determines whether the current Media Source configuration can process media of the supplied type.

Parameters:

`type` (str) –

A MIME type value

Returns (bool) –

`TRUE` when supported, `FALSE` otherwise

Since : 1.24

### Signals

#### on-source-close

    on_source_close_callback (GstMediaSource * self,
                              gpointer user_data)

Parameters:

`self` –
No description available
`user_data` –
No description available

Flags: Run Last

#### on-source-close

    function on_source_close_callback(self: GstMse.MediaSource, user_data: Object): {
        // javascript callback for the 'on-source-close' signal
    }

Parameters:

`self` (GstMse.MediaSource) –
No description available
`user_data` (Object) –
No description available

Flags: Run Last

#### on-source-close

    def on_source_close_callback (self, *user_data):
        #python callback for the 'on-source-close' signal

Parameters:

`self` (GstMse.MediaSource) –
No description available
`user_data` (variadic) –
No description available

Flags: Run Last

#### on-source-ended

    on_source_ended_callback (GstMediaSource * self,
                              gpointer user_data)

Emitted when self has ended, normally through gst_media_source_end_of_stream.

Specification

Parameters:

`self` –

The GstMediaSource that has just ended

`user_data` –
No description available

Flags: Run Last

Since : 1.24

#### on-source-ended

    function on_source_ended_callback(self: GstMse.MediaSource, user_data: Object): {
        // javascript callback for the 'on-source-ended' signal
    }

Emitted when self has ended, normally through GstMse.MediaSource.prototype.end_of_stream.

Specification

Parameters:

`self` (GstMse.MediaSource) –

The GstMse.MediaSource that has just ended

`user_data` (Object) –
No description available

Flags: Run Last

Since : 1.24

#### on-source-ended

    def on_source_ended_callback (self, *user_data):
        #python callback for the 'on-source-ended' signal

Emitted when self has ended, normally through GstMse.MediaSource.end_of_stream.

Specification

Parameters:

`self` (GstMse.MediaSource) –

The GstMse.MediaSource that has just ended

`user_data` (variadic) –
No description available

Flags: Run Last

Since : 1.24

#### on-source-open

    on_source_open_callback (GstMediaSource * self,
                             gpointer user_data)

Emitted when self has been opened.

Specification

Parameters:

`self` –

The GstMediaSource that has just opened

`user_data` –
No description available

Flags: Run Last

Since : 1.24

#### on-source-open

    function on_source_open_callback(self: GstMse.MediaSource, user_data: Object): {
        // javascript callback for the 'on-source-open' signal
    }

Emitted when self has been opened.

Specification

Parameters:

`self` (GstMse.MediaSource) –

The GstMse.MediaSource that has just opened

`user_data` (Object) –
No description available

Flags: Run Last

Since : 1.24

#### on-source-open

    def on_source_open_callback (self, *user_data):
        #python callback for the 'on-source-open' signal

Emitted when self has been opened.

Specification

Parameters:

`self` (GstMse.MediaSource) –

The GstMse.MediaSource that has just opened

`user_data` (variadic) –
No description available

Flags: Run Last

Since : 1.24

### Properties

#### active-source-buffers

    “active-source-buffers” GstSourceBufferList *

A GstSourceBufferList of every GstSourceBuffer in this Media Source that is considered active

Specification

Flags : Read

Since : 1.24

#### active-source-buffers

    “active-source-buffers” GstMse.SourceBufferList

A GstMse.SourceBufferList of every GstMse.SourceBuffer in this Media Source that is considered active

Specification

Flags : Read

Since : 1.24

#### active_source_buffers

    “self.props.active_source_buffers” GstMse.SourceBufferList

A GstMse.SourceBufferList of every GstMse.SourceBuffer in this Media Source that is considered active

Specification

Flags : Read

Since : 1.24

#### duration

    “duration” guint64

The Duration of the Media Source as a GstClockTime

Specification

Flags : Read / Write

Since : 1.24

#### duration

    “duration” Number

The Duration of the Media Source as a Number

Specification

Flags : Read / Write

Since : 1.24

#### duration

    “self.props.duration” int

The Duration of the Media Source as a int

Specification

Flags : Read / Write

Since : 1.24

#### position

    “position” guint64

The position of the player consuming from the Media Source

Flags : Read / Write

Since : 1.24

#### position

    “position” Number

The position of the player consuming from the Media Source

Flags : Read / Write

Since : 1.24

#### position

    “self.props.position” int

The position of the player consuming from the Media Source

Flags : Read / Write

Since : 1.24

#### ready-state

    “ready-state” GstMediaSourceReadyState *

The Ready State of the Media Source

Specification

Flags : Read

Since : 1.24

#### ready-state

    “ready-state” GstMse.MediaSourceReadyState

The Ready State of the Media Source

Specification

Flags : Read

Since : 1.24

#### ready_state

    “self.props.ready_state” GstMse.MediaSourceReadyState

The Ready State of the Media Source

Specification

Flags : Read

Since : 1.24

#### source-buffers

    “source-buffers” GstSourceBufferList *

A GstSourceBufferList of every GstSourceBuffer in this Media Source

Specification

Flags : Read

Since : 1.24

#### source-buffers

    “source-buffers” GstMse.SourceBufferList

A GstMse.SourceBufferList of every GstMse.SourceBuffer in this Media Source

Specification

Flags : Read

Since : 1.24

#### source_buffers

    “self.props.source_buffers” GstMse.SourceBufferList

A GstMse.SourceBufferList of every GstMse.SourceBuffer in this Media Source

Specification

Flags : Read

Since : 1.24

## GstMediaSourceRange

A structure describing a simplified version of the TimeRanges concept in the HTML specification, only representing a single start and end time.

Specification

### Members

`start` (GstClockTime) –

The start of this range.

`end` (GstClockTime) –

The end of this range.

Since : 1.24

## GstMse.MediaSourceRange

A structure describing a simplified version of the TimeRanges concept in the HTML specification, only representing a single start and end time.

Specification

### Members

`start` (Number) –

The start of this range.

`end` (Number) –

The end of this range.

Since : 1.24

## GstMse.MediaSourceRange

A structure describing a simplified version of the TimeRanges concept in the HTML specification, only representing a single start and end time.

Specification

### Members

`start` (int) –

The start of this range.

`end` (int) –

The end of this range.

Since : 1.24

## Functions

### gst_media_source_error_quark

    GQuark
    gst_media_source_error_quark ()

Any error type that can be reported by the Media Source API.

Returns –
No description available

Since : 1.24

### GstMse.MediaSourceError.prototype.quark

    function GstMse.MediaSourceError.prototype.quark(): {
        // javascript wrapper for 'gst_media_source_error_quark'
    }

Any error type that can be reported by the Media Source API.

Returns (GLib.Quark) –
No description available

Since : 1.24

### GstMse.MediaSourceError.quark

    def GstMse.MediaSourceError.quark ():
        #python wrapper for 'gst_media_source_error_quark'

Any error type that can be reported by the Media Source API.

Returns (GLib.Quark) –
No description available

Since : 1.24

## Enumerations

### GstMediaSourceEOSError

Reasons for ending a GstMediaSource using gst_media_source_end_of_stream.

Specification

##### Members

`GST_MEDIA_SOURCE_EOS_ERROR_NONE` (0) –

End the stream successfully

`GST_MEDIA_SOURCE_EOS_ERROR_NETWORK` (1) –

End the stream due to a networking error

`GST_MEDIA_SOURCE_EOS_ERROR_DECODE` (2) –

End the stream due to a decoding error

Since : 1.24

### GstMse.MediaSourceEOSError

Reasons for ending a GstMse.MediaSource using GstMse.MediaSource.prototype.end_of_stream.

Specification

##### Members

`GstMse.MediaSourceEOSError.NONE` (0) –

End the stream successfully

`GstMse.MediaSourceEOSError.NETWORK` (1) –

End the stream due to a networking error

`GstMse.MediaSourceEOSError.DECODE` (2) –

End the stream due to a decoding error

Since : 1.24

### GstMse.MediaSourceEOSError

Reasons for ending a GstMse.MediaSource using GstMse.MediaSource.end_of_stream.

Specification

##### Members

`GstMse.MediaSourceEOSError.NONE` (0) –

End the stream successfully

`GstMse.MediaSourceEOSError.NETWORK` (1) –

End the stream due to a networking error

`GstMse.MediaSourceEOSError.DECODE` (2) –

End the stream due to a decoding error

Since : 1.24

### GstMediaSourceError

Any error that can occur within GstMediaSource or GstSourceBuffer APIs. These values correspond directly to those in the Web IDL specification.

Specification

##### Members

`GST_MEDIA_SOURCE_ERROR_INVALID_STATE` (0) –
No description available
`GST_MEDIA_SOURCE_ERROR_TYPE` (1) –
No description available
`GST_MEDIA_SOURCE_ERROR_NOT_SUPPORTED` (2) –
No description available
`GST_MEDIA_SOURCE_ERROR_NOT_FOUND` (3) –
No description available
`GST_MEDIA_SOURCE_ERROR_QUOTA_EXCEEDED` (4) –
No description available

Since : 1.24

### GstMse.MediaSourceError

Any error that can occur within GstMse.MediaSource or GstMse.SourceBuffer APIs. These values correspond directly to those in the Web IDL specification.

Specification

##### Members

`GstMse.MediaSourceError.INVALID_STATE` (0) –
No description available
`GstMse.MediaSourceError.TYPE` (1) –
No description available
`GstMse.MediaSourceError.NOT_SUPPORTED` (2) –
No description available
`GstMse.MediaSourceError.NOT_FOUND` (3) –
No description available
`GstMse.MediaSourceError.QUOTA_EXCEEDED` (4) –
No description available

Since : 1.24

### GstMse.MediaSourceError

Any error that can occur within GstMse.MediaSource or GstMse.SourceBuffer APIs. These values correspond directly to those in the Web IDL specification.

Specification

##### Members

`GstMse.MediaSourceError.INVALID_STATE` (0) –
No description available
`GstMse.MediaSourceError.TYPE` (1) –
No description available
`GstMse.MediaSourceError.NOT_SUPPORTED` (2) –
No description available
`GstMse.MediaSourceError.NOT_FOUND` (3) –
No description available
`GstMse.MediaSourceError.QUOTA_EXCEEDED` (4) –
No description available

Since : 1.24

### GstMediaSourceReadyState

Describes the possible states of the Media Source.

Specification

##### Members

`GST_MEDIA_SOURCE_READY_STATE_CLOSED` (0) –

The GstMediaSource is not connected to any playback element.

`GST_MEDIA_SOURCE_READY_STATE_OPEN` (1) –

The GstMediaSource is connected to a playback element and ready to append data to its GstSourceBuffer (s).

`GST_MEDIA_SOURCE_READY_STATE_ENDED` (2) –

gst_media_source_end_of_stream has been called on the current GstMediaSource

Since : 1.24

### GstMse.MediaSourceReadyState

Describes the possible states of the Media Source.

Specification

##### Members

`GstMse.MediaSourceReadyState.CLOSED` (0) –

The GstMse.MediaSource is not connected to any playback element.

`GstMse.MediaSourceReadyState.OPEN` (1) –

The GstMse.MediaSource is connected to a playback element and ready to append data to its GstMse.SourceBuffer (s).

`GstMse.MediaSourceReadyState.ENDED` (2) –

GstMse.MediaSource.prototype.end_of_stream has been called on the current GstMse.MediaSource

Since : 1.24

### GstMse.MediaSourceReadyState

Describes the possible states of the Media Source.

Specification

##### Members

`GstMse.MediaSourceReadyState.CLOSED` (0) –

The GstMse.MediaSource is not connected to any playback element.

`GstMse.MediaSourceReadyState.OPEN` (1) –

The GstMse.MediaSource is connected to a playback element and ready to append data to its GstMse.SourceBuffer (s).

`GstMse.MediaSourceReadyState.ENDED` (2) –

GstMse.MediaSource.end_of_stream has been called on the current GstMse.MediaSource

Since : 1.24

The results of the search are